﻿// Attenuator.cs (c) Charles Petzold, 2009
using System;

namespace Petzold.SoundSynthesis
{
    public class Attenuator : ISampleProvider
    {
        int attenuation = 0;        // in db
        int multiplier = 65536;

        public ISampleProvider SampleProvider { get; set; }

        public int Attenuation
        {
            set
            {
                attenuation = value;
                multiplier = (int)(65536 * Math.Pow(10, attenuation / 20.0));
            }
            get
            {
                return attenuation;
            }
        }

        public short GetNextSample()
        {
            short sample = 0;

            if (SampleProvider != null)
                sample = SampleProvider.GetNextSample();

            sample = (short)((sample * multiplier) >> 16);

            return sample;
        }
    }
}
